#ifndef MATRIX001_H


//	XvCp̍ŏ̍sNX


#define MATRIX001_H 1

// s̏

enum MATRIX_TYPE{ 	undecided=0,upper_triangular,lowwer__triangular };

// 1̍sNX

class MATRIX_OWN_COLUMN{
	double* d;	//	sf[^[
	double k;	//	s̕я搔@Ⴆ΃XJ[{ꍇ͂̌Ŵݏ悸B
	int rmax;	//	s@s
	int max;	//	mۂĂz̃TCY
	MATRIX_TYPE flag;	//	s^Cv
public:
	MATRIX_OWN_COLUMN(){
		d=0;
		rmax=max=0;
	}
	MATRIX_OWN_COLUMN(int ar){
		d=0;
		rmax=max=0;
		alloc(ar);
	}
	~MATRIX_OWN_COLUMN(){
		delete [] d;
	}
	void alloc(int ar){
		if(max<ar){	//	zTCYsĂꍇ͍Ċmۂ
			max=rmax=ar;
			if(d)
				delete [] d;
			d=new double[rmax];
		}else{
			rmax=ar;
		}
		flag=undecided;
		k=1;
	}
	void rswap(int a,int b){	//	š
		double t=d[a];
		d[a]=d[b];
		d[b]=t;
		k=-k;
	}
	void set(double* ad){	//	sւ̒萔̑
		for(int n=0;n<rmax;n++)
			d[n]=ad[n];
	}
	void put(void){	//	sWo͂֕\
		for(int rn=0;rn<rmax;rn++){
			_tprintf(TEXT("%i %g\n"),rn,d[rn]);
		}
	}
	double& operator[](int n){
		return d[n];
	}
	friend class MATRIX;
};

//	sNX


class MATRIX{
	double* d;	//	sf[^[
	int cmax,rmax;	//	s@ s
	double k;	//	s̕я搔@Ⴆ΃XJ[{ꍇ͂̌Ŵݏ悸Bdet
	int max;	//	mۂĂz̃TCY
	MATRIX_TYPE flag;	//	s^Cv
public:
	MATRIX(){
		d=0;
		cmax=rmax=0;
		max=0;
		k=1;
	}
	MATRIX(int ar,int ac){
		d=0;
		cmax=rmax=0;
		max=0;
		k=1;
		alloc(ar,ac);
	}
	~MATRIX(){
		delete [] d;
	}
	void alloc(int ar,int ac){
		cmax=ac;
		rmax=ar;
		if(max<ar*ac){	//	zTCYsꍇ͔zĊmۂ
			if(d){
				delete [] d;
			}
			max=cmax*rmax;
			d=new double[max];
		}
		flag=undecided;
		k=1;
	}
	double* operator[](int n){
		return d+n*cmax;
	}
	void rswap(int a,int b){	//	š
		for(int i=0;i<cmax;i++){
			double t=(*this)[a][i];
			(*this)[a][i]=(*this)[b][i];
			(*this)[b][i]=t;
		}
		k=-k;	//	𔽓]
	}
	void set(double* ad){	//	sւ̒萔̑
		for(int n=0;n<cmax*rmax;n++)
			d[n]=ad[n];
	}
	void put(void){	//	sWo͂֕\
		for(int rn=0;rn<rmax;rn++){
			for(int cn=0;cn<cmax;cn++){
				_tprintf(TEXT("%g "),(*this)[rn][cn]);
			}
			_puttc(_T('\n'),stdout);
		}
	}
	void Triangular(bool pivoting=true){ // Opsɕϊ(KEX̑Oi@) Ńs|bgI̗LI
		int i,j,k;
		double uk1;
		for(k=0;k<rmax-1;k++){
			double m=0;
			double u;
			int n=k;
			if(pivoting){	//	s|bgIs
				for(i=k;i<rmax;i++){	//	Βlő̍š
					u=fabs( (*this)[i][k] );
					if(m!=0 && m<u){
						m=u;
						n=i;
					}
				}
				if(n!=k)
					rswap(n,k);	//	Βlő̍sƓւ
			}
			for(i=k+1;i<rmax;i++){
				uk1 = (*this)[i][k] / (*this)[k][k];	//	  ui1=ai1/a11
				(*this)[i][k]=0;		//	OpsɂƎQƂȂ̂ňʓIɂ͕sv
				for(j=k+1;j<cmax;j++){
					 (*this)[i][j] = (*this)[i][j] - uk1 * (*this)[k][j];	 //aji = aji - ui1 * a1j
				}
			}
		}
		flag=upper_triangular;	//	s^Cvݒ
	}
	void forward_sub(MATRIX_OWN_COLUMN& b,bool pivoting=true){ // Opsɕϊ(KEX̑Oi@)  Ńs|bgI̗LI
		int i,j,k;
		double uk1;
		for(k=0;k<rmax-1;k++){
			double m=0;
			double u=0;
			int n=k;
			if(pivoting){
				for(i=k;i<rmax;i++){	//	Βlő̍š
					u=fabs( (*this)[i][k] );
					if(m<u){
						m=u;
						n=i;
					}
				}
				if(m!=0 && n!=k){
					rswap(n,k);	//	Βlő̍sƓւׂĂ0͓̎ւȂ
					b.rswap(n,k);
				}
			}
			for(i=k+1;i<rmax;i++){
				uk1 = (*this)[i][k] / (*this)[k][k];	//	  ui1=ai1/a11
 				b[i] = b[i] - uk1 * b[k];
 				(*this)[i][k]=0;		//	OpsɂƎQƂȂ̂ňʓIɂ͕sv

				for(j=k+1;j<cmax;j++){
					 (*this)[i][j] = (*this)[i][j] - uk1 * (*this)[k][j];	 //aji = aji - ui1 * a1j
				}
			}
		}
		flag=upper_triangular;	//	s^Cvݒ
	}
	void forward_sub(MATRIX_OWN_COLUMN* b,int nmax, bool pivoting=true){ // Opsɕϊ(KEX̑Oi@) s|bgIL
		int i,j,k;
		double uk1;
		for(k=0;k<rmax-1;k++){
			double m=0;
			double u=0;
			int n=k;
			if(pivoting){
				for(i=k;i<rmax;i++){	//	Βlő̍š
					u=fabs( (*this)[i][k] );
					if(m<u){
						m=u;
						n=i;
					}
				}
				if(m!=0 && n!=k){
					rswap(n,k);	//	Βlő̍sƓւׂĂ0͓̎ւȂ
					for(int o=0;o<nmax;o++){
						b[o].rswap(n,k);
					}
				}
			}

			for(i=k+1;i<rmax;i++){
				uk1 = (*this)[i][k] / (*this)[k][k];	//	  ui1=ai1/a11
				for(int o=0;o<nmax;o++){
					MATRIX_OWN_COLUMN& t=b[o];
					t[i] = t[i] - uk1 * t[k];
				}
 				(*this)[i][k]=0;		//	OpsɂƎQƂȂ̂ňʓIɂ͕sv

				for(j=k+1;j<cmax;j++){
					 (*this)[i][j] = (*this)[i][j] - uk1 * (*this)[k][j];	 //aji = aji - ui1 * a1j
				}
			}
		}
		flag=upper_triangular;	//	s^Cvݒ
	}
	void backward_sub(MATRIX_OWN_COLUMN& b,MATRIX_OWN_COLUMN& x){	//	ޑ@ 炩ߏOpsɕϊĂKvB
		int i,j;
		for(i=rmax-1;0<=i;i--){
			double c=b[i]*b.k;
			for(j=i+1;j<rmax;j++){
				c -= (*this)[i][j] * x[j];
			}
			x[i] = c / (*this)[i][i];
		}
	}
	void backward_sub(MATRIX_OWN_COLUMN* b,MATRIX_OWN_COLUMN* x,int nmax){	//	ޑ@ 炩ߏOpsɕϊĂKvB
		int i,j;
		for(i=rmax-1;0<=i;i--){
			for(int n=0;n<nmax;n++){
				double c=b[n][i]*b[n].k;
				for(j=i+1;j<rmax;j++){
					c -= (*this)[i][j] * x[n][j];
				}
				x[n][i] = c / (*this)[i][i];
			}
		}
	}
	double det(void){	//	s̒lZo
		double a=k;
		if(flag==upper_triangular){	//	Ops
			for(int i=0;i<cmax;i++)
				a *= (*this)[i][i];
			return a;
		}else{	// OpsɕϊĂl߂
			MATRIX x(rmax,cmax);
			x=(*this);
			x.Triangular();
			return x.det();
		}
	}
	void zero(void){	//	s̏
		ZeroMemory((void*)d,sizeof(d[0])*rmax*cmax);
	}
};

#endif